UNIT mTBall;

interface

uses      winprocs,math,classes,Graphics,forms,dialogs;
// Uses-Klausel ggf. anpassen

type
   TBall = CLASS

     // Attribute
     private
        zx : Real;
        zy : Real;
        kenntCanvas : TCanvas;

     // Methoden
     private
        procedure loesche;
     public
        constructor init(px,py:Real);
        procedure bewege;
        procedure zeichne;
        function links : Integer;
        function rechts : integer;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TBall: Methodendefinition 
//+---------------------------------------------------------------------

//-------- loesche (private) -------------------------------------------
procedure TBall.loesche;
begin
         kenntCanvas.Pen.Color := screen.activeForm.color;
         kenntCanvas.Pen.Width:=1;
         kenntCanvas.Brush.color := screen.activeForm.color;
         kenntCanvas.Brush.style := bssolid;
         kenntCanvas.ellipse(round(zx)-20,round(zy)-20,round(zx)+20,round(zy)+20);
end;

//-------- init (public) -----------------------------------------------
constructor TBall.init(px,py:Real);
begin
  if screen.activeForm=nil then
  begin
    MessageDlg('Ein Ball wurde vor dem Formular erzeugt',mtError,[mbOK],0);
    Halt;
  end;

  kenntCanvas:=screen.activeForm.Canvas;
  zx:=px;
  zy:=py;
 self.zeichne
end;

//-------- bewege (public) ---------------------------------------------
procedure TBall.bewege;
begin
  loesche;
  zx := zx +0.01;   //  ggf anpassen
  zeichne;
  application.ProcessMessages
end;

//-------- zeichne (public) --------------------------------------------
procedure TBall.zeichne;
begin
   kenntCanvas.Pen.Color:=clBlack;
   kenntCanvas.Pen.Width:=1;
   kenntCanvas.Brush.color:=clgreen;
   kenntCanvas.Brush.Style:=bsSolid; //bsClear;
   kenntCanvas.ellipse(round(zx)-20,round(zy)-20,round(zx)+20,round(zy)+20);
end;

//-------- links (public) ----------------------------------------------
function TBall.links : Integer;
begin
   result := round(zx)-20
end;

//-------- rechts (public) ---------------------------------------------
function TBall.rechts : integer;
begin
   result := round(zx)+20
end;

//-------- gibFrei (public) --------------------------------------------
destructor TBall.gibFrei;
begin
  loesche;
  inherited destroy
end;

end.
